ALTER TABLE X4PERM.x4p_user ADD METADATA VARCHAR2(700 CHAR) NULL;

-- update display names of existing group
UPDATE X4PERM.X4P_GROUP SET DISPLAY_NAME = 'X4 Control Center Administrator', DESCRIPTION='Group for Control Center standard Administrators' WHERE NAME = 'Administrators';

-- insert new group
INSERT INTO X4PERM.X4P_GROUP(name, display_name, description, created, lastmodified) VALUES (            
	    'Users'
     	,'X4 Control Center User'
		,'Group for Control Center standard Users'
	    ,CURRENT_TIMESTAMP
	    ,CURRENT_TIMESTAMP);

-- insert new roles
INSERT INTO X4PERM.X4P_ROLE(NAME, DISPLAY_NAME, DESCRIPTION, CREATED, LASTMODIFIED, MODULE) VALUES (
	'X4 User Management Administrator', 'X4 User Management Administrator', 'Role for administering all users, groups, roles and permissions',
	 CURRENT_TIMESTAMP, 
	 CURRENT_TIMESTAMP,
	 (SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='URM'));
	 
INSERT INTO X4PERM.X4P_ROLE(NAME, DISPLAY_NAME, DESCRIPTION, CREATED, LASTMODIFIED, MODULE) VALUES (
	'X4 User Management User', 'X4 User Management User', 'Role for listing all users, groups, roles and permissions',
	 CURRENT_TIMESTAMP, 
	 CURRENT_TIMESTAMP,
	 (SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='URM'));
	 
INSERT INTO X4PERM.X4P_ROLE(NAME, DISPLAY_NAME, DESCRIPTION, CREATED, LASTMODIFIED, MODULE) VALUES (
	'X4 Scheduler Administrator', 'X4 Scheduler Administrator', 'Role for administering scheduled executions',
	 CURRENT_TIMESTAMP, 
	 CURRENT_TIMESTAMP,
	 (SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='X4BAM'));
	 
INSERT INTO X4PERM.X4P_ROLE(NAME, DISPLAY_NAME, DESCRIPTION, CREATED, LASTMODIFIED, MODULE) VALUES (
	'X4 Scheduler User', 'X4 Scheduler User', 'Role for listing scheduled executions',
	 CURRENT_TIMESTAMP, 
	 CURRENT_TIMESTAMP,
	 (SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='X4BAM'));
	 
INSERT INTO X4PERM.X4P_ROLE(NAME, DISPLAY_NAME, DESCRIPTION, CREATED, LASTMODIFIED, MODULE) VALUES (
	'X4 Monitoring Administrator', 'X4 Monitoring Administrator', 'Role for administering process instances',
	 CURRENT_TIMESTAMP, 
	 CURRENT_TIMESTAMP,
	 (SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='X4BAM'));
	 
INSERT INTO X4PERM.X4P_ROLE(NAME, DISPLAY_NAME, DESCRIPTION, CREATED, LASTMODIFIED, MODULE) VALUES (
	'X4 Monitoring User', 'X4 Monitoring User', 'Role for listing process instances',
	 CURRENT_TIMESTAMP, 
	 CURRENT_TIMESTAMP,
	 (SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='X4BAM'));
	 
INSERT INTO X4PERM.X4P_ROLE(NAME, DISPLAY_NAME, DESCRIPTION, CREATED, LASTMODIFIED, MODULE) VALUES (
	'X4 Services User', 'X4 Services User', 'Role for listing services',
	 CURRENT_TIMESTAMP, 
	 CURRENT_TIMESTAMP,
	 (SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='X4BAM')); 
	 
INSERT INTO X4PERM.X4P_ROLE(NAME, DISPLAY_NAME, DESCRIPTION, CREATED, LASTMODIFIED, MODULE) VALUES (
	'X4 License', 'X4 License', 'Role for display license information',
	 CURRENT_TIMESTAMP, 
	 CURRENT_TIMESTAMP,
	 (SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='X4BAM'));

-- insert new permission templates
insert into X4PERM.X4P_perm_template(object_type, action, description, MODULE, name) values (
	'instance', 'stop', 'Parameter has to be *', (select id from X4PERM.X4P_module where name = 'X4BAM'), 'Stop instances'
);
insert into X4PERM.X4P_perm_template(object_type, action, description, MODULE, name) values (
	'instance', 'restart', 'Parameter has to be *', (select id from X4PERM.X4P_module where name = 'X4BAM'), 'Restart instances'
);
insert into X4PERM.X4P_perm_template(object_type, action, description, MODULE, name) values (
	'process', 'start', 'Parameter has to be *', (select id from X4PERM.X4P_module where name = 'X4BAM'), 'Start processes'
);
insert into X4PERM.X4P_perm_template(object_type, action, description, MODULE, name) values (
	'scheduler', 'create', 'Parameter has to be *', (select id from X4PERM.X4P_module where name = 'X4BAM'), 'Create scheduled execution'
);
insert into X4PERM.X4P_perm_template(object_type, action, description, MODULE, name) values (
	'scheduler', 'update', 'Parameter has to be *', (select id from X4PERM.X4P_module where name = 'X4BAM'), 'Update scheduled execution'
);
insert into X4PERM.X4P_perm_template(object_type, action, description, MODULE, name) values (
	'scheduler', 'delete', 'Parameter has to be *', (select id from X4PERM.X4P_module where name = 'X4BAM'), 'Delete scheduled execution'
);
insert into X4PERM.X4P_perm_template(object_type, action, description, MODULE, name) values (
	'scheduler', 'list', 'Parameter has to be *', (select id from X4PERM.X4P_module where name = 'X4BAM'), 'List scheduled executions'
);
insert into X4PERM.X4P_perm_template(object_type, action, description, MODULE, name) values (
	'scheduler', 'read', 'Parameter has to be *', (select id from X4PERM.X4P_module where name = 'X4BAM'), 'Read scheduled execution'
);
insert into X4PERM.X4P_perm_template(object_type, action, description, MODULE, name) values (
	'scheduler', 'reload', 'Parameter has to be *', (select id from X4PERM.X4P_module where name = 'X4BAM'), 'Reload configuration'
);
insert into X4PERM.X4P_perm_template(object_type, action, description, MODULE, name) values (
	'user', 'create', 'Parameter has to be *', (select id from X4PERM.X4P_module where name = 'URM'), 'Create user'
);
insert into X4PERM.X4P_perm_template(object_type, action, description, MODULE, name) values (
	'user', 'update', 'Parameter has to be *', (select id from X4PERM.X4P_module where name = 'URM'), 'Update user'
);
insert into X4PERM.X4P_perm_template(object_type, action, description, MODULE, name) values (
	'user', 'delete', 'Parameter has to be *', (select id from X4PERM.X4P_module where name = 'URM'), 'Delete user'
);
insert into X4PERM.X4P_perm_template(object_type, action, description, MODULE, name) values (
	'group', 'create', 'Parameter has to be *', (select id from X4PERM.X4P_module where name = 'URM'), 'Create group'
);
insert into X4PERM.X4P_perm_template(object_type, action, description, MODULE, name) values (
	'group', 'update', 'Parameter has to be *', (select id from X4PERM.X4P_module where name = 'URM'), 'Update group'
);
insert into X4PERM.X4P_perm_template(object_type, action, description, MODULE, name) values (
	'group', 'delete', 'Parameter has to be *', (select id from X4PERM.X4P_module where name = 'URM'), 'Delete group'
);
insert into X4PERM.X4P_perm_template(object_type, action, description, MODULE, name) values (
	'role', 'create', 'Parameter has to be *', (select id from X4PERM.X4P_module where name = 'URM'), 'Create role'
);
insert into X4PERM.X4P_perm_template(object_type, action, description, MODULE, name) values (
	'role', 'update', 'Parameter has to be *', (select id from X4PERM.X4P_module where name = 'URM'), 'Update role'
);
insert into X4PERM.X4P_perm_template(object_type, action, description, MODULE, name) values (
	'role', 'delete', 'Parameter has to be *', (select id from X4PERM.X4P_module where name = 'URM'), 'Delete role'
);
insert into X4PERM.X4P_perm_template(object_type, action, description, MODULE, name) values (
	'permission', 'create', 'Parameter has to be *', (select id from X4PERM.X4P_module where name = 'URM'), 'Create permission'
);
insert into X4PERM.X4P_perm_template(object_type, action, description, MODULE, name) values (
	'permission', 'update', 'Parameter has to be *', (select id from X4PERM.X4P_module where name = 'URM'), 'Update permission'
);
insert into X4PERM.X4P_perm_template(object_type, action, description, MODULE, name) values (
	'permission', 'delete', 'Parameter has to be *', (select id from X4PERM.X4P_module where name = 'URM'), 'Delete permission'
);
insert into X4PERM.X4P_perm_template(object_type, action, description, MODULE, name) values (
	'user', 'read', 'Parameter has to be *', (select id from X4PERM.X4P_module where name = 'URM'), 'Read user'
);
insert into X4PERM.X4P_perm_template(object_type, action, description, MODULE, name) values (
	'group', 'read', 'Parameter has to be *', (select id from X4PERM.X4P_module where name = 'URM'), 'Read group'
);
insert into X4PERM.X4P_perm_template(object_type, action, description, MODULE, name) values (
	'role', 'read', 'Parameter has to be *', (select id from X4PERM.X4P_module where name = 'URM'), 'Read role'
);
insert into X4PERM.X4P_perm_template(object_type, action, description, MODULE, name) values (
	'permission', 'read', 'Parameter has to be *', (select id from X4PERM.X4P_module where name = 'URM'), 'Read permission'
);
insert into X4PERM.X4P_perm_template(object_type, action, description, MODULE, name) values (
	'services', 'list', 'Parameter has to be *', (select id from X4PERM.X4P_module where name = 'X4BAM'), 'List services'
);
insert into X4PERM.X4P_perm_template(object_type, action, description, MODULE, name) values (
	'services', 'read', 'Parameter has to be *', (select id from X4PERM.X4P_module where name = 'X4BAM'), 'Read service'
);
insert into X4PERM.X4P_perm_template(object_type, action, description, MODULE, name) values (
	'license', 'read', 'Parameter has to be *', (select id from X4PERM.X4P_module where name = 'X4BAM'), 'Read license'
);
insert into X4PERM.X4P_perm_template(object_type, action, description, MODULE, name) values (
	'project', 'list', 'Parameter has to be *', (select id from X4PERM.X4P_module where name = 'X4BAM'), 'List processes'
);
insert into X4PERM.X4P_perm_template(object_type, action, description, MODULE, name) values (
	'project', 'read', 'Parameter has to be *', (select id from X4PERM.X4P_module where name = 'X4BAM'), 'Read process'
);
	 
-- insert new permissions
INSERT INTO X4PERM.X4P_PERM(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='X4BAM'),'instance','stop','Can stop instances', 'X4 BAM Stop Instances', '*');
INSERT INTO X4PERM.X4P_PERM(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='X4BAM'),'instance','restart','Can restart instances', 'X4 BAM Restart Instances', '*');
INSERT INTO X4PERM.X4P_PERM(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='X4BAM'),'process','start','Can start processes', 'X4 BAM Start Processes', '*');
INSERT INTO X4PERM.X4P_PERM(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='X4BAM'),'scheduler','create','Can create scheduled executions', 'X4 BAM Create Scheduled Executions', '*');
INSERT INTO X4PERM.X4P_PERM(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='X4BAM'),'scheduler','update','Can update scheduled executions', 'X4 BAM Update Scheduled Executions', '*');
INSERT INTO X4PERM.X4P_PERM(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='X4BAM'),'scheduler','delete','Can delete scheduled executions', 'X4 BAM Delete Scheduled Executions', '*');
INSERT INTO X4PERM.X4P_PERM(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='X4BAM'),'scheduler','list','Can list scheduled executions', 'X4 BAM List Scheduled Executions', '*');
INSERT INTO X4PERM.X4P_PERM(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='X4BAM'),'scheduler','read','Can read scheduled execution', 'X4 BAM Read Scheduled Execution', '*');
INSERT INTO X4PERM.X4P_PERM(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='X4BAM'),'scheduler','reload','Can reload scheduler configuration', 'X4 BAM Reload Configuration', '*');
INSERT INTO X4PERM.X4P_PERM(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='URM'),'user','create','Can create users', 'X4 URM Create Users', '*');
INSERT INTO X4PERM.X4P_PERM(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='URM'),'user','update','Can update users', 'X4 URM Update Users', '*');
INSERT INTO X4PERM.X4P_PERM(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='URM'),'user','delete','Can delete users', 'X4 URM Delete Users', '*');
INSERT INTO X4PERM.X4P_PERM(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='URM'),'group','create','Can create groups', 'X4 URM Create Groups', '*');
INSERT INTO X4PERM.X4P_PERM(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='URM'),'group','update','Can update groups', 'X4 URM Update Groups', '*');
INSERT INTO X4PERM.X4P_PERM(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='URM'),'group','delete','Can delete groups', 'X4 URM Delete Groups', '*');
INSERT INTO X4PERM.X4P_PERM(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='URM'),'role','create','Can create roles', 'X4 URM Create Roles', '*');
INSERT INTO X4PERM.X4P_PERM(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='URM'),'role','update','Can update roles', 'X4 URM Update Roles', '*');
INSERT INTO X4PERM.X4P_PERM(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='URM'),'role','delete','Can delete roles', 'X4 URM Delete Roles', '*');
INSERT INTO X4PERM.X4P_PERM(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='URM'),'permission','create','Can create permissions', 'X4 URM Create Permissions', '*');
INSERT INTO X4PERM.X4P_PERM(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='URM'),'permission','update','Can update permissions', 'X4 URM Update Permissions', '*');
INSERT INTO X4PERM.X4P_PERM(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='URM'),'permission','delete','Can delete permissions', 'X4 URM Delete Permissions', '*');
INSERT INTO X4PERM.X4P_PERM(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='URM'),'user','read','Can read user', 'X4 URM Read User', '*');
INSERT INTO X4PERM.X4P_PERM(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='URM'),'group','read','Can read group', 'X4 URM Read Group', '*');
INSERT INTO X4PERM.X4P_PERM(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='URM'),'role','read','Can read role', 'X4 URM Read Role', '*');
INSERT INTO X4PERM.X4P_PERM(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='URM'),'permission','read','Can read permission', 'X4 URM Read Permission', '*');
INSERT INTO X4PERM.X4P_PERM(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='X4BAM'),'services','list','Can list serivces', 'X4 BAM List Services', '*');
INSERT INTO X4PERM.X4P_PERM(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='X4BAM'),'services','read','Can read serivce', 'X4 BAM Read Service', '*');
INSERT INTO X4PERM.X4P_PERM(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='X4BAM'),'license','read','Can read license', 'X4 BAM Read License', '*');
INSERT INTO X4PERM.X4P_PERM(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='X4BAM'),'project','list','Can list processes', 'X4 BAM List Processes', '*');
INSERT INTO X4PERM.X4P_PERM(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='X4BAM'),'project','read','Can read processes', 'X4 BAM Read Process', '*');
	
-- assign permission to roles
INSERT INTO X4PERM.X4P_ROLE_PERM(ROLE_id, PERMISSION_id)
	SELECT X4P_ROLE.id, X4P_PERM.id FROM X4PERM.X4P_ROLE, X4PERM.X4P_PERM WHERE X4P_ROLE.NAME='X4 User Management Administrator'
		AND X4P_PERM.MODULE=(SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='URM') and X4P_PERM.ACTION in ('create','update','delete','administer');
		
INSERT INTO X4PERM.X4P_ROLE_PERM(ROLE_id, PERMISSION_id)
	SELECT X4P_ROLE.id, X4P_PERM.id FROM X4PERM.X4P_ROLE, X4PERM.X4P_PERM WHERE X4P_ROLE.NAME='X4 User Management User'
		AND X4P_PERM.MODULE=(SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='URM') and X4P_PERM.ACTION in ('list','read');
		
INSERT INTO X4PERM.X4P_ROLE_PERM(ROLE_id, PERMISSION_id)
	SELECT X4P_ROLE.id, X4P_PERM.id FROM X4PERM.X4P_ROLE, X4PERM.X4P_PERM WHERE X4P_ROLE.NAME='X4 Scheduler Administrator'
		AND X4P_PERM.MODULE=(SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='X4BAM') and X4P_PERM.ACTION in ('create','update','delete','reload') and X4P_PERM.OBJECT_TYPE = 'scheduler';
		
INSERT INTO X4PERM.X4P_ROLE_PERM(ROLE_id, PERMISSION_id)
	SELECT X4P_ROLE.id, X4P_PERM.id FROM X4PERM.X4P_ROLE, X4PERM.X4P_PERM WHERE X4P_ROLE.NAME='X4 Scheduler User'
		AND X4P_PERM.MODULE=(SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='X4BAM') and X4P_PERM.ACTION in ('list','read') and X4P_PERM.OBJECT_TYPE = 'scheduler';
		
INSERT INTO X4PERM.X4P_ROLE_PERM(ROLE_id, PERMISSION_id)
	SELECT X4P_ROLE.id, X4P_PERM.id FROM X4PERM.X4P_ROLE, X4PERM.X4P_PERM WHERE X4P_ROLE.NAME='X4 Monitoring Administrator'
		AND X4P_PERM.MODULE=(SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='X4BAM') and X4P_PERM.ACTION in ('start','stop','restart') and X4P_PERM.OBJECT_TYPE in ('process','instance');
		
INSERT INTO X4PERM.X4P_ROLE_PERM(ROLE_id, PERMISSION_id)
	SELECT X4P_ROLE.id, X4P_PERM.id FROM X4PERM.X4P_ROLE, X4PERM.X4P_PERM WHERE X4P_ROLE.NAME='X4 Monitoring User'
		AND X4P_PERM.MODULE=(SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='X4BAM') and X4P_PERM.ACTION in ('list','read') and X4P_PERM.OBJECT_TYPE = 'project';
		
INSERT INTO X4PERM.X4P_ROLE_PERM(ROLE_id, PERMISSION_id)
	SELECT X4P_ROLE.id, X4P_PERM.id FROM X4PERM.X4P_ROLE, X4PERM.X4P_PERM WHERE X4P_ROLE.NAME='X4 Services User'
		AND X4P_PERM.MODULE=(SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='X4BAM') and X4P_PERM.ACTION in ('list','read') and X4P_PERM.OBJECT_TYPE = 'services';
	
INSERT INTO X4PERM.X4P_ROLE_PERM(ROLE_id, PERMISSION_id)
	SELECT X4P_ROLE.id, X4P_PERM.id FROM X4PERM.X4P_ROLE, X4PERM.X4P_PERM WHERE X4P_ROLE.NAME='X4 License'
		AND X4P_PERM.MODULE=(SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='X4BAM') and X4P_PERM.ACTION = 'read' and X4P_PERM.OBJECT_TYPE = 'license';
		
INSERT INTO X4PERM.X4P_ROLE_PERM(ROLE_id, PERMISSION_id)
	SELECT X4P_ROLE.id, X4P_PERM.id FROM X4PERM.X4P_ROLE, X4PERM.X4P_PERM WHERE X4P_ROLE.NAME='X4 URM administer'
		AND X4P_PERM.MODULE=(SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='URM') and X4P_PERM.ACTION in ('create','update','delete');
		
INSERT INTO X4PERM.X4P_ROLE_PERM(ROLE_id, PERMISSION_id)
	SELECT X4P_ROLE.id, X4P_PERM.id FROM X4PERM.X4P_ROLE, X4PERM.X4P_PERM WHERE X4P_ROLE.NAME='X4 URM list'
		AND X4P_PERM.MODULE=(SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='URM') and X4P_PERM.ACTION in ('read');
		
INSERT INTO X4PERM.X4P_ROLE_PERM(ROLE_id, PERMISSION_id)
	SELECT X4P_ROLE.id, X4P_PERM.id FROM X4PERM.X4P_ROLE, X4PERM.X4P_PERM WHERE X4P_ROLE.NAME='x4bam_admin'
		AND X4P_PERM.MODULE=(SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='X4BAM') and X4P_PERM.ACTION in ('create','update','delete','reload','start','stop','restart') and X4P_PERM.OBJECT_TYPE not LIKE 'x4bam_%';
		
INSERT INTO X4PERM.X4P_ROLE_PERM(ROLE_id, PERMISSION_id)
	SELECT X4P_ROLE.id, X4P_PERM.id FROM X4PERM.X4P_ROLE, X4PERM.X4P_PERM WHERE X4P_ROLE.NAME='x4bam_user'
		AND X4P_PERM.MODULE=(SELECT id FROM X4PERM.X4P_MODULE WHERE NAME='X4BAM') and X4P_PERM.ACTION in ('read','list') and X4P_PERM.OBJECT_TYPE not LIKE 'x4bam_%';
		
-- assign roles to group
INSERT INTO X4PERM.X4P_GROUP_ROLE( group_id, role_id)            
      SELECT
        NEW.GROUP_ID,
        NEW.ROLE_ID
      FROM
        (SELECT X4PERM.X4P_GROUP.ID GROUP_ID, X4PERM.X4P_ROLE.ID ROLE_ID FROM X4PERM.X4P_GROUP, X4PERM.X4P_ROLE WHERE X4PERM.X4P_GROUP.NAME='Administrators'
              AND X4PERM.X4P_ROLE.MODULE IN (SELECT ID FROM X4PERM.X4P_MODULE WHERE NAME IN('X4BAM','URM'))) NEW
      LEFT JOIN X4PERM.X4P_GROUP_ROLE EXISTING ON NEW.GROUP_ID = EXISTING.GROUP_ID AND NEW.ROLE_ID = EXISTING.ROLE_ID 
      WHERE EXISTING.GROUP_ID IS NULL AND EXISTING.ROLE_ID IS NULL;

INSERT INTO X4PERM.X4P_GROUP_ROLE( group_id, role_id)            
	    SELECT X4PERM.X4P_GROUP.ID, X4PERM.X4P_ROLE.ID FROM X4PERM.X4P_GROUP, X4PERM.X4P_ROLE WHERE X4PERM.X4P_GROUP.NAME='Users' AND X4PERM.X4P_ROLE.NAME NOT LIKE '%Administrator' 
	    	AND X4PERM.X4P_ROLE.MODULE IN (SELECT ID FROM X4PERM.X4P_MODULE WHERE NAME IN('X4BAM','URM'));

COMMIT;
