CREATE TABLE X4SERVER.PLACEHOLDER_GROUPS(
	x4_id bigserial NOT NULL,
	x4_name character varying(55) NOT NULL,
 	CONSTRAINT PK_PLACEHOLDER_GROUPS PRIMARY KEY (x4_id),
 	CONSTRAINT UK_PLACEHOLDER_GROUPS UNIQUE (x4_name)
);

GRANT ALL ON X4SERVER.PLACEHOLDER_GROUPS TO X4SERVER;

CREATE TABLE X4SERVER.PLACEHOLDER_VALUES(
	x4_id bigserial NOT NULL,
	x4_name character varying(55) NOT NULL,
	x4_value character varying(255) NULL,
	x4_type integer NULL,
	x4_group_id bigint NOT NULL,
 	CONSTRAINT PK_PLACEHOLDER_VALUES PRIMARY KEY (x4_id),
	CONSTRAINT UK_PLACEHOLDER_VALUES UNIQUE (x4_name, x4_group_id),
 	CONSTRAINT FK_PLACEHOLDER_VALUES_PLACEHOLDER_GROUPS FOREIGN KEY (x4_group_id)
      REFERENCES X4SERVER.PLACEHOLDER_GROUPS (x4_id) ON UPDATE NO ACTION ON DELETE NO ACTION
);

GRANT ALL ON X4SERVER.PLACEHOLDER_VALUES TO X4SERVER;

ALTER TABLE x4server.placeholder_values OWNER TO x4server;
ALTER TABLE x4server.placeholder_groups OWNER TO x4server;