#include "include/schema.include"
#include "include/type.include"

-- inserts templates and user to begin with

-- SET search_path = 'Permission'; 

-- insert module for URM
INSERT INTO X4_SCHEMA.MODULES(NAME) VALUES ('URM');
INSERT INTO X4_SCHEMA.MODULES(NAME) VALUES ('X4BAM');
INSERT INTO X4_SCHEMA.MODULES(NAME) VALUES ('Custom Placeholders');

-- insert permission templates
insert into X4_SCHEMA.PERM_TEMPLATES(object_type, action, description, MODULE, name) values (
	'group', 'list', 'Parameter has to be *', (select id from X4_SCHEMA.MODULES where name = 'URM'), 'URM group list'
);
insert into X4_SCHEMA.PERM_TEMPLATES(object_type, action, description, MODULE, name) values (
	'role', 'list', 'Parameter has to be *', (select id from X4_SCHEMA.MODULES where name = 'URM'), 'URM role list'
);
insert into X4_SCHEMA.PERM_TEMPLATES(object_type, action, description, MODULE, name) values (
	'user', 'list', 'Parameter has to be *', (select id from X4_SCHEMA.MODULES where name = 'URM'), 'URM user list'
);
insert into X4_SCHEMA.PERM_TEMPLATES(object_type, action, description, MODULE, name) values (
	'permission', 'list', 'Parameter has to be *', (select id from X4_SCHEMA.MODULES where name = 'URM'), 'URM permission list'
);
insert into X4_SCHEMA.PERM_TEMPLATES(object_type, action, description, MODULE, name) values (
	'pwpolicies', 'list', 'Parameter has to be *', (select id from X4_SCHEMA.MODULES where name = 'URM'), 'URM password policies list'
);
insert into X4_SCHEMA.PERM_TEMPLATES(object_type, action, description, MODULE, name) values (
	'module', 'list', 'Parameter has to be the name of a module or * for any module', (select id from X4_SCHEMA.MODULES where name = 'URM'), 'URM module list'
);
INSERT INTO X4_SCHEMA.PERM_TEMPLATES(object_type, action, description, module, name) values (
	'group', 'read', 'Parameter has to be the name of a group or * for any group', (select id from X4_SCHEMA.MODULES where name = 'Custom Placeholders'), 'Custom Placeholders Read Data'
);
INSERT INTO X4_SCHEMA.PERM_TEMPLATES(object_type, action, description, module, name) values (
	'group', 'write', 'Parameter has to be the name of a group or * for any group', (select id from X4_SCHEMA.MODULES where name = 'Custom Placeholders'), 'Custom Placeholders Write Data'
);

insert into X4_SCHEMA.PERM_TEMPLATES(object_type, action, description, MODULE, name) values (
	'instance', 'stop', 'Parameter has to be *', (select id from X4_SCHEMA.MODULES where name = 'X4BAM'), 'Stop instances'
);
insert into X4_SCHEMA.PERM_TEMPLATES(object_type, action, description, MODULE, name) values (
	'instance', 'restart', 'Parameter has to be *', (select id from X4_SCHEMA.MODULES where name = 'X4BAM'), 'Restart instances'
);
insert into X4_SCHEMA.PERM_TEMPLATES(object_type, action, description, MODULE, name) values (
	'process', 'start', 'Parameter has to be *', (select id from X4_SCHEMA.MODULES where name = 'X4BAM'), 'Start processes'
);
insert into X4_SCHEMA.PERM_TEMPLATES(object_type, action, description, MODULE, name) values (
	'scheduler', 'create', 'Parameter has to be *', (select id from X4_SCHEMA.MODULES where name = 'X4BAM'), 'Create scheduled execution'
);
insert into X4_SCHEMA.PERM_TEMPLATES(object_type, action, description, MODULE, name) values (
	'scheduler', 'update', 'Parameter has to be *', (select id from X4_SCHEMA.MODULES where name = 'X4BAM'), 'Update scheduled execution'
);
insert into X4_SCHEMA.PERM_TEMPLATES(object_type, action, description, MODULE, name) values (
	'scheduler', 'delete', 'Parameter has to be *', (select id from X4_SCHEMA.MODULES where name = 'X4BAM'), 'Delete scheduled execution'
);
insert into X4_SCHEMA.PERM_TEMPLATES(object_type, action, description, MODULE, name) values (
	'scheduler', 'list', 'Parameter has to be *', (select id from X4_SCHEMA.MODULES where name = 'X4BAM'), 'List scheduled executions'
);
insert into X4_SCHEMA.PERM_TEMPLATES(object_type, action, description, MODULE, name) values (
	'scheduler', 'read', 'Parameter has to be *', (select id from X4_SCHEMA.MODULES where name = 'X4BAM'), 'Read scheduled execution'
);
insert into X4_SCHEMA.PERM_TEMPLATES(object_type, action, description, MODULE, name) values (
	'scheduler', 'reload', 'Parameter has to be *', (select id from X4_SCHEMA.MODULES where name = 'X4BAM'), 'Reload configuration'
);
insert into X4_SCHEMA.PERM_TEMPLATES(object_type, action, description, MODULE, name) values (
	'jmx', 'access', 'Parameter has to be *', (select id from X4_SCHEMA.MODULES where name = 'X4BAM'), 'Access JMX Administration'
);
insert into X4_SCHEMA.PERM_TEMPLATES(object_type, action, description, MODULE, name) values (
	'user', 'create', 'Parameter has to be *', (select id from X4_SCHEMA.MODULES where name = 'URM'), 'Create user'
);
insert into X4_SCHEMA.PERM_TEMPLATES(object_type, action, description, MODULE, name) values (
	'user', 'update', 'Parameter has to be *', (select id from X4_SCHEMA.MODULES where name = 'URM'), 'Update user'
);
insert into X4_SCHEMA.PERM_TEMPLATES(object_type, action, description, MODULE, name) values (
	'user', 'delete', 'Parameter has to be *', (select id from X4_SCHEMA.MODULES where name = 'URM'), 'Delete user'
);
insert into X4_SCHEMA.PERM_TEMPLATES(object_type, action, description, MODULE, name) values (
	'group', 'create', 'Parameter has to be *', (select id from X4_SCHEMA.MODULES where name = 'URM'), 'Create group'
);
insert into X4_SCHEMA.PERM_TEMPLATES(object_type, action, description, MODULE, name) values (
	'group', 'update', 'Parameter has to be *', (select id from X4_SCHEMA.MODULES where name = 'URM'), 'Update group'
);
insert into X4_SCHEMA.PERM_TEMPLATES(object_type, action, description, MODULE, name) values (
	'group', 'delete', 'Parameter has to be *', (select id from X4_SCHEMA.MODULES where name = 'URM'), 'Delete group'
);
insert into X4_SCHEMA.PERM_TEMPLATES(object_type, action, description, MODULE, name) values (
	'role', 'create', 'Parameter has to be *', (select id from X4_SCHEMA.MODULES where name = 'URM'), 'Create role'
);
insert into X4_SCHEMA.PERM_TEMPLATES(object_type, action, description, MODULE, name) values (
	'role', 'update', 'Parameter has to be *', (select id from X4_SCHEMA.MODULES where name = 'URM'), 'Update role'
);
insert into X4_SCHEMA.PERM_TEMPLATES(object_type, action, description, MODULE, name) values (
	'role', 'delete', 'Parameter has to be *', (select id from X4_SCHEMA.MODULES where name = 'URM'), 'Delete role'
);
insert into X4_SCHEMA.PERM_TEMPLATES(object_type, action, description, MODULE, name) values (
	'permission', 'create', 'Parameter has to be *', (select id from X4_SCHEMA.MODULES where name = 'URM'), 'Create permission'
);
insert into X4_SCHEMA.PERM_TEMPLATES(object_type, action, description, MODULE, name) values (
	'permission', 'update', 'Parameter has to be *', (select id from X4_SCHEMA.MODULES where name = 'URM'), 'Update permission'
);
insert into X4_SCHEMA.PERM_TEMPLATES(object_type, action, description, MODULE, name) values (
	'permission', 'delete', 'Parameter has to be *', (select id from X4_SCHEMA.MODULES where name = 'URM'), 'Delete permission'
);
insert into X4_SCHEMA.PERM_TEMPLATES(object_type, action, description, MODULE, name) values (
	'user', 'read', 'Parameter has to be *', (select id from X4_SCHEMA.MODULES where name = 'URM'), 'Read user'
);
insert into X4_SCHEMA.PERM_TEMPLATES(object_type, action, description, MODULE, name) values (
	'group', 'read', 'Parameter has to be *', (select id from X4_SCHEMA.MODULES where name = 'URM'), 'Read group'
);
insert into X4_SCHEMA.PERM_TEMPLATES(object_type, action, description, MODULE, name) values (
	'role', 'read', 'Parameter has to be *', (select id from X4_SCHEMA.MODULES where name = 'URM'), 'Read role'
);
insert into X4_SCHEMA.PERM_TEMPLATES(object_type, action, description, MODULE, name) values (
	'permission', 'read', 'Parameter has to be *', (select id from X4_SCHEMA.MODULES where name = 'URM'), 'Read permission'
);
insert into X4_SCHEMA.PERM_TEMPLATES(object_type, action, description, MODULE, name) values (
	'services', 'list', 'Parameter has to be *', (select id from X4_SCHEMA.MODULES where name = 'X4BAM'), 'List services'
);
insert into X4_SCHEMA.PERM_TEMPLATES(object_type, action, description, MODULE, name) values (
	'services', 'read', 'Parameter has to be *', (select id from X4_SCHEMA.MODULES where name = 'X4BAM'), 'Read service'
);
insert into X4_SCHEMA.PERM_TEMPLATES(object_type, action, description, MODULE, name) values (
	'license', 'read', 'Parameter has to be *', (select id from X4_SCHEMA.MODULES where name = 'X4BAM'), 'Read license'
);
insert into X4_SCHEMA.PERM_TEMPLATES(object_type, action, description, MODULE, name) values (
	'project', 'list', 'Parameter has to be *', (select id from X4_SCHEMA.MODULES where name = 'X4BAM'), 'List processes'
);
insert into X4_SCHEMA.PERM_TEMPLATES(object_type, action, description, MODULE, name) values (
	'project', 'read', 'Parameter has to be *', (select id from X4_SCHEMA.MODULES where name = 'X4BAM'), 'Read process'
);

-- system user   to be used for creates not triggered by any user but some scripts
#ifdef MSSQL
SET IDENTITY_INSERT X4_SCHEMA.USERS ON;
#endif
INSERT INTO X4_SCHEMA.USERS(id, first_name, last_name, login_name, created, created_by, lastmodified, lastmodified_by, password,
	password_change_required, active, deleted) 
VALUES ( 0, 'System', 'User', 'system', NOW, 0,
	NOW, 0, '$2a$10$Q2V7RyCiM8LeuGrDWXslHu0Tjqmg5Ysbwlge/owgpcZ1TC0nEJ3N2',
	FALSE, FALSE, 1);
#ifdef MSSQL
SET IDENTITY_INSERT X4_SCHEMA.USERS OFF;
#endif
		
-- admin user
INSERT INTO X4_SCHEMA.USERS( first_name, last_name, login_name, created, lastmodified, password, password_change_required, active) 
VALUES ( 'SP', 'Admin' ,'admin' 
		,NOW 
		,NOW 
	    ,'$2a$10$Q2V7RyCiM8LeuGrDWXslHu0Tjqmg5Ysbwlge/owgpcZ1TC0nEJ3N2'
	    , FALSE, TRUE);

-- insert extended state entry for admin
INSERT INTO X4_SCHEMA.EXTENDED_USER_STATES(user_id) VALUES ((SELECT id FROM X4_SCHEMA.USERS WHERE login_name='admin'));

-- insert default group for admin
INSERT INTO X4_SCHEMA.GROUPS(name, display_name, created, lastmodified, private) VALUES (            
	    'admin'
		,'admin'
	    ,NOW
	    ,NOW
	    ,TRUE
	    );
	    
-- insert Permissions
INSERT INTO X4_SCHEMA.PERMS(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='URM'),'permission','list','Can list permissions', 'X4 URM List Permissions', '*');
INSERT INTO X4_SCHEMA.PERMS(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='URM'),'role','list','Can list roles', 'X4 URM List Roles', '*');
INSERT INTO X4_SCHEMA.PERMS(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='URM'),'group','list','Can list groups', 'X4 URM List Groups', '*');
INSERT INTO X4_SCHEMA.PERMS(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='URM'),'user','list','Can list users', 'X4 URM List Users', '*');
INSERT INTO X4_SCHEMA.PERMS(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='URM'),'pwpolicies','list','Can list password policies', 'X4 URM List Password Policies', '*');
INSERT INTO X4_SCHEMA.PERMS(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='URM'),'pwpolicies','administer','Can administer password policies', 'X4 URM Administer Password Policies', '*');
INSERT INTO X4_SCHEMA.PERMS(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='URM'),'module','list','Can list all modules', 'X4 URM List All Modules', '*');
INSERT INTO X4_SCHEMA.PERMS(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='Custom Placeholders'),'group','read','May read data', 'X4 Custom Placeholders Read Data', '*');
INSERT INTO X4_SCHEMA.PERMS(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='Custom Placeholders'),'group','write','May write data', 'X4 Custom Placeholders Write Data', '*');
	
INSERT INTO X4_SCHEMA.PERMS(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='X4BAM'),'instance','stop','Can stop instances', 'X4 BAM Stop Instances', '*');
INSERT INTO X4_SCHEMA.PERMS(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='X4BAM'),'instance','restart','Can restart instances', 'X4 BAM Restart Instances', '*');
INSERT INTO X4_SCHEMA.PERMS(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='X4BAM'),'process','start','Can start processes', 'X4 BAM Start Processes', '*');
INSERT INTO X4_SCHEMA.PERMS(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='X4BAM'),'scheduler','create','Can create scheduled executions', 'X4 BAM Create Scheduled Executions', '*');
INSERT INTO X4_SCHEMA.PERMS(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='X4BAM'),'scheduler','update','Can update scheduled executions', 'X4 BAM Update Scheduled Executions', '*');
INSERT INTO X4_SCHEMA.PERMS(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='X4BAM'),'scheduler','delete','Can delete scheduled executions', 'X4 BAM Delete Scheduled Executions', '*');
INSERT INTO X4_SCHEMA.PERMS(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='X4BAM'),'scheduler','list','Can list scheduled executions', 'X4 BAM List Scheduled Executions', '*');
INSERT INTO X4_SCHEMA.PERMS(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='X4BAM'),'scheduler','read','Can read scheduled execution', 'X4 BAM Read Scheduled Execution', '*');
INSERT INTO X4_SCHEMA.PERMS(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='X4BAM'),'scheduler','reload','Can reload scheduler configuration', 'X4 BAM Reload Configuration', '*');
INSERT INTO X4_SCHEMA.PERMS(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='X4BAM'),'jmx','access','Can access jmx administration', 'X4 BAM Access JMX Administration', '*');
INSERT INTO X4_SCHEMA.PERMS(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='URM'),'user','create','Can create users', 'X4 URM Create Users', '*');
INSERT INTO X4_SCHEMA.PERMS(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='URM'),'user','update','Can update users', 'X4 URM Update Users', '*');
INSERT INTO X4_SCHEMA.PERMS(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='URM'),'user','delete','Can delete users', 'X4 URM Delete Users', '*');
INSERT INTO X4_SCHEMA.PERMS(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='URM'),'group','create','Can create groups', 'X4 URM Create Groups', '*');
INSERT INTO X4_SCHEMA.PERMS(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='URM'),'group','update','Can update groups', 'X4 URM Update Groups', '*');
INSERT INTO X4_SCHEMA.PERMS(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='URM'),'group','delete','Can delete groups', 'X4 URM Delete Groups', '*');
INSERT INTO X4_SCHEMA.PERMS(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='URM'),'role','create','Can create roles', 'X4 URM Create Roles', '*');
INSERT INTO X4_SCHEMA.PERMS(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='URM'),'role','update','Can update roles', 'X4 URM Update Roles', '*');
INSERT INTO X4_SCHEMA.PERMS(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='URM'),'role','delete','Can delete roles', 'X4 URM Delete Roles', '*');
INSERT INTO X4_SCHEMA.PERMS(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='URM'),'permission','create','Can create permissions', 'X4 URM Create Permissions', '*');
INSERT INTO X4_SCHEMA.PERMS(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='URM'),'permission','update','Can update permissions', 'X4 URM Update Permissions', '*');
INSERT INTO X4_SCHEMA.PERMS(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='URM'),'permission','delete','Can delete permissions', 'X4 URM Delete Permissions', '*');
INSERT INTO X4_SCHEMA.PERMS(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='URM'),'user','read','Can read user', 'X4 URM Read User', '*');
INSERT INTO X4_SCHEMA.PERMS(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='URM'),'group','read','Can read group', 'X4 URM Read Group', '*');
INSERT INTO X4_SCHEMA.PERMS(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='URM'),'role','read','Can read role', 'X4 URM Read Role', '*');
INSERT INTO X4_SCHEMA.PERMS(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='URM'),'permission','read','Can read permission', 'X4 URM Read Permission', '*');
INSERT INTO X4_SCHEMA.PERMS(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='X4BAM'),'services','list','Can list serivces', 'X4 BAM List Services', '*');
INSERT INTO X4_SCHEMA.PERMS(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='X4BAM'),'services','read','Can read serivce', 'X4 BAM Read Service', '*');
INSERT INTO X4_SCHEMA.PERMS(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='X4BAM'),'license','read','Can read license', 'X4 BAM Read License', '*');
INSERT INTO X4_SCHEMA.PERMS(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='X4BAM'),'project','list','Can list processes', 'X4 BAM List Processes', '*');
INSERT INTO X4_SCHEMA.PERMS(MODULE, OBJECT_TYPE, ACTION, DESCRIPTION, NAME, PARAMETER) VALUES (
	(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='X4BAM'),'project','read','Can read processes', 'X4 BAM Read Process', '*');
	
-- insert Roles
INSERT INTO X4_SCHEMA.ROLES(NAME, DISPLAY_NAME, DESCRIPTION, CREATED, LASTMODIFIED, MODULE) VALUES (
	'X4 User Management Administrator', 'X4 User Management Administrator', 'Role for administering all users, groups, roles and permissions',
	 NOW, 
	 NOW,
	 (SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='URM'));
	 
INSERT INTO X4_SCHEMA.ROLES(NAME, DISPLAY_NAME, DESCRIPTION, CREATED, LASTMODIFIED, MODULE) VALUES (
	'X4 User Management User', 'X4 User Management User', 'Role for listing all users, groups, roles and permissions',
	 NOW, 
	 NOW,
	 (SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='URM'));
	 
INSERT INTO X4_SCHEMA.ROLES(NAME, DISPLAY_NAME, DESCRIPTION, CREATED, LASTMODIFIED, MODULE) VALUES (
	'X4 Scheduler Administrator', 'X4 Scheduler Administrator', 'Role for administering scheduled executions',
	 NOW, 
	 NOW,
	 (SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='X4BAM'));
	 
INSERT INTO X4_SCHEMA.ROLES(NAME, DISPLAY_NAME, DESCRIPTION, CREATED, LASTMODIFIED, MODULE) VALUES (
	'X4 Scheduler User', 'X4 Scheduler User', 'Role for listing scheduled executions',
	 NOW, 
	 NOW,
	 (SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='X4BAM'));
	 
INSERT INTO X4_SCHEMA.ROLES(NAME, DISPLAY_NAME, DESCRIPTION, CREATED, LASTMODIFIED, MODULE) VALUES (
	'X4 Monitoring Administrator', 'X4 Monitoring Administrator', 'Role for administering process instances',
	 NOW, 
	 NOW,
	 (SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='X4BAM'));
	 
INSERT INTO X4_SCHEMA.ROLES(NAME, DISPLAY_NAME, DESCRIPTION, CREATED, LASTMODIFIED, MODULE) VALUES (
	'X4 Monitoring User', 'X4 Monitoring User', 'Role for listing process instances',
	 NOW, 
	 NOW,
	 (SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='X4BAM'));
	 
INSERT INTO X4_SCHEMA.ROLES(NAME, DISPLAY_NAME, DESCRIPTION, CREATED, LASTMODIFIED, MODULE) VALUES (
	'X4 Services User', 'X4 Services User', 'Role for listing services',
	 NOW, 
	 NOW,
	 (SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='X4BAM'));
	 
INSERT INTO X4_SCHEMA.ROLES(NAME, DISPLAY_NAME, DESCRIPTION, CREATED, LASTMODIFIED, MODULE) VALUES (
	'X4 JMX Administrator', 'X4 JMX Administrator', 'Role for accessing jmx administration',
	 NOW, 
	 NOW,
	 (SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='X4BAM'));

INSERT INTO X4_SCHEMA.ROLES(NAME, DISPLAY_NAME, DESCRIPTION, CREATED, LASTMODIFIED, MODULE) VALUES (
	'X4 License', 'X4 License', 'Role for display license information',
	 NOW, 
	 NOW,
	 (SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='X4BAM'));

INSERT INTO X4_SCHEMA.ROLES(NAME, DISPLAY_NAME, DESCRIPTION, CREATED, LASTMODIFIED, MODULE) VALUES (
	'X4 Custom Placeholders read', 'X4 Custom Placeholders read', 'Role for listing all custom placeholders',
	 NOW, 
	 NOW,
	 (SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='Custom Placeholders'));	 

INSERT INTO X4_SCHEMA.ROLES(NAME, DISPLAY_NAME, DESCRIPTION, CREATED, LASTMODIFIED, MODULE) VALUES (
	'X4 Custom Placeholders write', 'X4 Custom Placeholders write', 'Role for editing all custom placeholders',
	 NOW, 
	 NOW,
	 (SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='Custom Placeholders'));	 

-- couple Role and Permission together
INSERT INTO X4_SCHEMA.ROLE_PERM(ROLE_id, PERMISSION_id)
	SELECT ROLES.id, PERMS.id FROM X4_SCHEMA.ROLES, X4_SCHEMA.PERMS WHERE ROLES.NAME='X4 User Management Administrator'
		AND PERMS.MODULE=(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='URM') and PERMS.ACTION in ('list','read', 'create','update','delete','administer');
		
INSERT INTO X4_SCHEMA.ROLE_PERM(ROLE_id, PERMISSION_id)
	SELECT ROLES.id, PERMS.id FROM X4_SCHEMA.ROLES, X4_SCHEMA.PERMS WHERE ROLES.NAME='X4 User Management User'
		AND PERMS.MODULE=(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='URM') and PERMS.ACTION in ('list','read');
		
INSERT INTO X4_SCHEMA.ROLE_PERM(ROLE_id, PERMISSION_id)
	SELECT ROLES.id, PERMS.id FROM X4_SCHEMA.ROLES, X4_SCHEMA.PERMS WHERE ROLES.NAME='X4 Scheduler Administrator'
		AND PERMS.MODULE=(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='X4BAM') and PERMS.ACTION in ('list','read', 'create','update','delete','reload') and PERMS.OBJECT_TYPE = 'scheduler';
		
INSERT INTO X4_SCHEMA.ROLE_PERM(ROLE_id, PERMISSION_id)
	SELECT ROLES.id, PERMS.id FROM X4_SCHEMA.ROLES, X4_SCHEMA.PERMS WHERE ROLES.NAME='X4 Scheduler User'
		AND PERMS.MODULE=(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='X4BAM') and PERMS.ACTION in ('list','read') and PERMS.OBJECT_TYPE = 'scheduler';
		
INSERT INTO X4_SCHEMA.ROLE_PERM(ROLE_id, PERMISSION_id)
	SELECT ROLES.id, PERMS.id FROM X4_SCHEMA.ROLES, X4_SCHEMA.PERMS WHERE ROLES.NAME='X4 Monitoring Administrator'
		AND PERMS.MODULE=(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='X4BAM') and PERMS.ACTION in ('list','read', 'start','stop','restart') and PERMS.OBJECT_TYPE in ('process','instance');
		
INSERT INTO X4_SCHEMA.ROLE_PERM(ROLE_id, PERMISSION_id)
	SELECT ROLES.id, PERMS.id FROM X4_SCHEMA.ROLES, X4_SCHEMA.PERMS WHERE ROLES.NAME='X4 Monitoring User'
		AND PERMS.MODULE=(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='X4BAM') and PERMS.ACTION in ('list','read') and PERMS.OBJECT_TYPE = 'project';

INSERT INTO X4_SCHEMA.ROLE_PERM(ROLE_id, PERMISSION_id)
	SELECT ROLES.id, PERMS.id FROM X4_SCHEMA.ROLES, X4_SCHEMA.PERMS WHERE ROLES.NAME='X4 Services User'
		AND PERMS.MODULE=(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='X4BAM') and PERMS.ACTION in ('list','read') and PERMS.OBJECT_TYPE = 'services';

INSERT INTO X4_SCHEMA.ROLE_PERM(ROLE_id, PERMISSION_id)
	SELECT ROLES.id, PERMS.id FROM X4_SCHEMA.ROLES, X4_SCHEMA.PERMS WHERE ROLES.NAME='X4 JMX Administrator'
		AND PERMS.MODULE=(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='X4BAM') and PERMS.OBJECT_TYPE = 'jmx';
		
INSERT INTO X4_SCHEMA.ROLE_PERM(ROLE_id, PERMISSION_id)
	SELECT ROLES.id, PERMS.id FROM X4_SCHEMA.ROLES, X4_SCHEMA.PERMS WHERE ROLES.NAME='X4 License'
		AND PERMS.MODULE=(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='X4BAM') and PERMS.ACTION = 'read' and PERMS.OBJECT_TYPE = 'license';

INSERT INTO X4_SCHEMA.ROLE_PERM(ROLE_id, PERMISSION_id) VALUES (          
	(SELECT id FROM X4_SCHEMA.ROLES WHERE NAME='X4 Custom Placeholders read')
	,(SELECT id FROM X4_SCHEMA.PERMS WHERE MODULE=(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='Custom Placeholders') 
		AND NAME='X4 Custom Placeholders Read Data'));

INSERT INTO X4_SCHEMA.ROLE_PERM(ROLE_id, PERMISSION_id) VALUES (          
	(SELECT id FROM X4_SCHEMA.ROLES WHERE NAME='X4 Custom Placeholders write')
	,(SELECT id FROM X4_SCHEMA.PERMS WHERE MODULE=(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='Custom Placeholders') 
		AND NAME='X4 Custom Placeholders Write Data'));
		
INSERT INTO X4_SCHEMA.ROLE_PERM(ROLE_id, PERMISSION_id) VALUES (          
	(SELECT id FROM X4_SCHEMA.ROLES WHERE NAME='X4 Custom Placeholders write')
	,(SELECT id FROM X4_SCHEMA.PERMS WHERE MODULE=(SELECT id FROM X4_SCHEMA.MODULES WHERE NAME='Custom Placeholders') 
		AND NAME='X4 Custom Placeholders Read Data'));
		
-- insert group adminstrator
INSERT INTO X4_SCHEMA.GROUPS(name, display_name, description, created, lastmodified) VALUES (            
	    'Users'
		,'X4 Control Center User'
        ,'Group for Control Center standard Users'
	    ,NOW
	    ,NOW
	    );
		
INSERT INTO X4_SCHEMA.GROUPS(name, display_name, description, created, lastmodified) VALUES (            
	    'Administrators'
		,'X4 Control Center Administrator'
        ,'Group for Control Center standard Administrators'
	    ,NOW
	    ,NOW
	    );
	    
-- couple user and group
INSERT INTO X4_SCHEMA.USER_GROUP(user_Id, group_Id) VALUES (
	    (SELECT X4_SCHEMA.USERS.ID FROM X4_SCHEMA.USERS WHERE X4_SCHEMA.USERS.LOGIN_NAME='admin')
	    ,(SELECT ID FROM X4_SCHEMA.GROUPS WHERE X4_SCHEMA.GROUPS.NAME = 'Users'));
	    
INSERT INTO X4_SCHEMA.USER_GROUP(user_Id, group_Id) VALUES (
	    (SELECT X4_SCHEMA.USERS.ID FROM X4_SCHEMA.USERS WHERE X4_SCHEMA.USERS.LOGIN_NAME='admin')
	    ,(SELECT ID FROM X4_SCHEMA.GROUPS WHERE X4_SCHEMA.GROUPS.NAME = 'Administrators'));
	    
INSERT INTO X4_SCHEMA.USER_GROUP(user_Id, group_Id) VALUES (
	    (SELECT X4_SCHEMA.USERS.ID FROM X4_SCHEMA.USERS WHERE X4_SCHEMA.USERS.LOGIN_NAME='admin')
	    ,(SELECT ID FROM X4_SCHEMA.GROUPS WHERE X4_SCHEMA.GROUPS.NAME = 'admin'));

-- couple group and role
INSERT INTO X4_SCHEMA.GROUP_ROLE( group_id, role_id)            
	    SELECT X4_SCHEMA.GROUPS.ID, X4_SCHEMA.ROLES.ID FROM X4_SCHEMA.GROUPS, X4_SCHEMA.ROLES WHERE X4_SCHEMA.GROUPS.NAME='Administrators';

INSERT INTO X4_SCHEMA.GROUP_ROLE( group_id, role_id)            
	    SELECT X4_SCHEMA.GROUPS.ID, X4_SCHEMA.ROLES.ID FROM X4_SCHEMA.GROUPS, X4_SCHEMA.ROLES WHERE X4_SCHEMA.GROUPS.NAME='Users' and X4_SCHEMA.ROLES.NAME not like '%Administrator' and X4_SCHEMA.ROLES.NAME not like 'X4 Custom Placeholders%';
	   
-- insert default password policies
INSERT INTO X4_SCHEMA.PASSWORD_POLICIES (CREATED_BY, MIN_LEN, MIN_DIGITS, MIN_UPPERCASE, MIN_LOWERCASE, MIN_SPECIAL_CHAR,
        		FAIL_ATTEMPTS_TO_LOCK, LOCKING_PERIOD, MAX_PASSWORD_AGE, PASSWORD_HISTORY_ENTRIES) VALUES (
        0, 8, 0, 0, 0, 0, 10, 600, 31536000, 0);
		