<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="2.0"
	xmlns:webapp="http://softproject.de/webapp/1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output media-type="text/xml" method="xml" />
	<xsl:template match="*">
		<xsl:copy>
			<xsl:apply-templates select="@*" />
			<xsl:apply-templates select="node()" />
		</xsl:copy>
	</xsl:template>
	<xsl:template match="@*" mode="#all">
		<xsl:copy-of select="." />
	</xsl:template>
	<xsl:template
		match="text()|processing-instruction()|comment()">
		<xsl:copy-of select="." />
	</xsl:template>
	<!-- Units are removed to avoid breaking existing behaviour of grid layout
		if they are set by any reason -->
	<xsl:template
		match="webapp:ColumnDefinitions/webapp:Column/@units" />
	<!-- Remove attributes that got here because of ColumnDefinition inheriting
		PaddingAndMarginElement and thus obtaining all fonts, colours, etc. -->
	<xsl:template
		match="webapp:ColumnDefinitions/webapp:Column/@fontFamily" />
	<xsl:template
		match="webapp:ColumnDefinitions/webapp:Column/@fontSize" />
	<xsl:template
		match="webapp:ColumnDefinitions/webapp:Column/@fontWeight" />
	<xsl:template
		match="webapp:ColumnDefinitions/webapp:Column/@fontStretch" />
	<xsl:template
		match="webapp:ColumnDefinitions/webapp:Column/@fontStyle" />
	<xsl:template
		match="webapp:ColumnDefinitions/webapp:Column/@background" />
	<xsl:template
		match="webapp:ColumnDefinitions/webapp:Column/@foreground" />
	<xsl:template
		match="webapp:ColumnDefinitions/webapp:Column/@disabled" />
	<xsl:template
		match="webapp:ColumnDefinitions/webapp:Column/@enabled" />
	<xsl:template
		match="webapp:ColumnDefinitions/webapp:Column/@border" />
	<xsl:template
		match="webapp:ColumnDefinitions/webapp:Column/@height" />
	<xsl:template
		match="webapp:ColumnDefinitions/webapp:Column/@visible" />
	<xsl:template
		match="webapp:ColumnDefinitions/webapp:Column/@textOverflow" />
</xsl:stylesheet>
<!--Created by X4 Designer, Copyright © SoftProject GmbH. All rights reserved. -->