<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet
	xmlns:webapp="http://softproject.de/webapp/1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output media-type="text/xml" method="xml"></xsl:output>
	<xsl:template match="*/webapp:ComboBox/@displayProperty">
		<xsl:attribute name="displayProperty">
			<xsl:choose>
				<xsl:when test="starts-with(., '#')">
					<xsl:value-of select="."></xsl:value-of>			
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="concat('#', .)"></xsl:value-of>
				</xsl:otherwise>
			</xsl:choose>
    </xsl:attribute>
	</xsl:template>
	<xsl:template match="*/webapp:ComboBox/@iconProperty">
		<xsl:attribute name="iconProperty">
			<xsl:choose>
				<xsl:when test="starts-with(., '#')">
					<xsl:value-of select="."></xsl:value-of>			
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="concat('#', .)"></xsl:value-of>
				</xsl:otherwise>
			</xsl:choose>
    </xsl:attribute>
	</xsl:template>
	<xsl:template match="*/webapp:ComboBox/@iconColorProperty">
		<xsl:attribute name="iconColorProperty">
			<xsl:choose>
				<xsl:when test="starts-with(., '#')">
					<xsl:value-of select="."></xsl:value-of>			
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="concat('#', .)"></xsl:value-of>
				</xsl:otherwise>
			</xsl:choose>
    </xsl:attribute>
	</xsl:template>
	<xsl:template match="*/webapp:ComboBox/@valueProperty">
		<xsl:attribute name="valueProperty">
      		<xsl:choose>
				<xsl:when test="starts-with(., '#')">
					<xsl:value-of select="."></xsl:value-of>			
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="concat('#', .)"></xsl:value-of>
				</xsl:otherwise>
			</xsl:choose>
    </xsl:attribute>
	</xsl:template>
	<xsl:template match="*">
		<xsl:copy>
			<xsl:apply-templates select="@*"></xsl:apply-templates>
			<xsl:apply-templates select="node()"></xsl:apply-templates>
		</xsl:copy>
	</xsl:template>
	<xsl:template match="@*">
		<xsl:copy-of select="."></xsl:copy-of>
	</xsl:template>
	<xsl:template
		match="text()|processing-instruction()|comment()">
		<xsl:copy-of select="."></xsl:copy-of>
	</xsl:template>
</xsl:stylesheet>