<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:output media-type="text/xml" method="xml"/>
  <xsl:param name="project"/>
  <xsl:param name="repository"/>
  <xsl:template match="*">
    <xsl:copy>
      <xsl:apply-templates select="@*"/>
      <xsl:apply-templates select="node()"/>
    </xsl:copy>
  </xsl:template>
  <xsl:template match="@*">
    <xsl:copy-of select="."/>
  </xsl:template>
  <xsl:template match="text()|processing-instruction()|comment()">
    <xsl:copy-of select="."/>
  </xsl:template>
  <!-- Matches Rest & Soap Service -->
  <!-- Matches File Service -->
  <!-- Matches Include -->
  <!-- Matches WSDL Processes -->
  <xsl:template match="Operation/@process[starts-with(. , 'x4db:/')] | Service/@path[starts-with(. , 'x4db:/')] | Include/@href[starts-with(. , 'x4db:/')] | Wsdl[@mode='PROCESS']/@url[starts-with(. , 'x4db:/')]">
    <xsl:choose>
      <xsl:when test="not(starts-with(., concat('x4db:/', $repository)))">
        <xsl:copy-of select="."/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:choose>
          <xsl:when test="starts-with(., concat('x4db:/', $repository, '/', $project))">
            <xsl:attribute name="{name(.)}">
              <xsl:value-of select="substring-after(. , concat('x4db:/', $repository, '/', $project, '/'))"/>
            </xsl:attribute>
          </xsl:when>
          <xsl:otherwise>
            <xsl:attribute name="{name(.)}">
              <xsl:value-of select="concat('xstore://', replace(. , concat('x4db:/', $repository, '/'), ''))"/>
            </xsl:attribute>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
</xsl:stylesheet>
<!--Created by X4 Designer, Copyright © SoftProject GmbH. All rights reserved. -->