<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="2.0"
  xmlns:webapp="http://softproject.de/webapp/1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:output media-type="text/xml" method="xml"/>
  <xsl:template match="*">
    <xsl:copy>
      <xsl:apply-templates select="@*"/>
      <xsl:apply-templates select="node()"/>
    </xsl:copy>
  </xsl:template>
  <xsl:template match=" //webapp:DetailComponent//webapp:*[local-name() = 'Tab']">
  	<xsl:call-template name="content"/>
  </xsl:template>
  <xsl:template match=" //webapp:DetailComponent//webapp:*[local-name() = 'ListView']">
    <xsl:copy>
      <xsl:choose>
        <xsl:when test="@border">
          <xsl:for-each select="./@*">
            <xsl:if test="not(name() = 'border' or name() = 'width' or name() = 'height' or name() = 'units' or contains(name(), 'padding') or contains(name(),'margin'))">
              <xsl:copy-of select="."/>
            </xsl:if>
          </xsl:for-each>
          <xsl:element name="BoxLayout" namespace="http://softproject.de/webapp/1.0">
         	<xsl:copy-of select="@border"></xsl:copy-of>
            <xsl:apply-templates select="node()"/>
          </xsl:element>
        </xsl:when>
        <xsl:otherwise>
          <xsl:for-each select="./@*">
            <xsl:if test="not(name() = 'border' or name() = 'width' or name() = 'height' or name() = 'units' or contains(name(), 'padding') or contains(name(),'margin'))">
              <xsl:copy-of select="."/>
            </xsl:if>
          </xsl:for-each>
          <xsl:apply-templates select="node()"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:copy>
  </xsl:template>
  <xsl:template match="(//webapp:DetailComponent//webapp:*[not(local-name() = 'Column') and not(local-name() = 'Tab') and not(local-name() = 'ListView')
	and ((@height and not(local-name() = 'Image')) or
	(@width and not(local-name() = 'Image')) or
	(@border and not(local-name() = 'Card') and not(local-name() = 'Image') and not(local-name() = 'Textbox')) or
	@marginTop or @marginBottom or @marginLeft or @marginRight or @marginUnits or @paddingTop or @paddingBottom or @paddingLeft or
	@paddingRight or @paddingUnits or @units)])">
    <xsl:element name="BoxLayout" namespace="http://softproject.de/webapp/1.0">
          <xsl:choose>
            <xsl:when test="local-name() = 'Card' or local-name() = 'TextBox'">
              <xsl:for-each select="./@*">
                <xsl:if test="name() = 'width' or name() = 'height' or name() = 'units' or contains(name(), 'padding') or contains(name(), 'margin')">
                  <xsl:copy-of select="."/>
                </xsl:if>
              </xsl:for-each>
            </xsl:when>
            <xsl:when test="local-name() = 'Image'">
              <xsl:for-each select="./@*">
                <xsl:if test="contains(name(), 'padding') or contains(name(), 'margin')">
                  <xsl:copy-of select="."/>
                </xsl:if>
              </xsl:for-each>
            </xsl:when>
     		<xsl:when test="local-name() = 'ResponsiveLayout' or local-name() = 'FlowLayout' or local-name() = 'TabLayout' or local-name() = 'GridLayout'">
				<xsl:for-each select="./@*">
					<xsl:if
						test="name() = 'border' or name() = 'width' or name() = 'height' or name() = 'units' or contains(name(), 'padding') or contains(name(), 'margin') or name() = 'horizontalAlign'">
						<xsl:copy-of select="." />
					</xsl:if>
				</xsl:for-each>
			</xsl:when>
            <xsl:otherwise>
              <xsl:for-each select="./@*">
                <xsl:if test="name() = 'border' or name() = 'width' or name() = 'height' or name() = 'units' or contains(name(), 'padding') or contains(name(), 'margin')">
                  <xsl:copy-of select="."/>
                </xsl:if>
              </xsl:for-each> 
            </xsl:otherwise>
          </xsl:choose>
          <xsl:call-template name="content"/>
    </xsl:element>
  </xsl:template>
  <!-- Templates for the content inside of a BoxLayout -->
  <xsl:template name="content">
    <xsl:copy>
      <xsl:choose>
        <!-- Special case for chart because the height is migrated
        	 to minHeight with the same value if it is pixel and 0
        	 in the another cases-->
        <xsl:when test="local-name() = 'Chart'">
          <xsl:choose>
            <xsl:when test="./@units = 'pixels'">
              <xsl:attribute name="minHeight" select="./@height"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:attribute name="minHeight" select="0"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:when>
        <!-- Keep some attributes for the special cases like card, image or textbox -->
        <xsl:when test="local-name() = 'Card' or local-name() = 'TextBox'">
          <xsl:for-each select="./@*">
            <xsl:if test="not(name() = 'width' or name() = 'height' or name() = 'units' or contains(name(), 'padding') or contains(name(),'margin'))">
              <xsl:copy-of select="."/>
            </xsl:if>
          </xsl:for-each>
        </xsl:when>
        <xsl:when test="local-name() = 'Image'">
          <xsl:for-each select="./@*">
            <xsl:if test="not(contains(name(), 'padding') or contains(name(),'margin'))">
              <xsl:copy-of select="."/>
            </xsl:if>
          </xsl:for-each>
        </xsl:when>
     	<xsl:when test="local-name() = 'ResponsiveLayout' or local-name() = 'FlowLayout' or local-name() = 'TabLayout' or local-name() = 'GridLayout'">
			<xsl:for-each select="./@*">
				<xsl:if
					test="not(name() = 'border' or name() = 'width' or name() = 'height' or name() = 'units' or contains(name(), 'padding') or contains(name(), 'margin') or name() = 'horizontalAlign')">
					<xsl:copy-of select="." />
				</xsl:if>
			</xsl:for-each>
		</xsl:when>
        <!-- Copy attributes which has not been removed of child controls/layouts -->
        <xsl:otherwise>
          <xsl:for-each select="./@*">
            <xsl:if test="not(name() = 'border' or name() = 'width' or name() = 'height' or name() = 'units' or contains(name(), 'padding') or contains(name(),'margin'))">
              <xsl:copy-of select="."/>
            </xsl:if>
          </xsl:for-each>
        </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="node()"/>
    </xsl:copy>
  </xsl:template>
  <xsl:template match="@*" mode="#all">
    <xsl:copy-of select="."/>
  </xsl:template>
  <xsl:template match="text()|processing-instruction()|comment()">
    <xsl:copy-of select="."/>
  </xsl:template>
</xsl:stylesheet>
<!--Created by X4 Designer, Copyright © SoftProject GmbH. All rights reserved. -->