<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:output media-type="text/xml" method="xml"/>
  
  <xsl:variable name="oldAdapterClass">de.softproject.x4.auth.rest.KeycloakAdapter</xsl:variable>
  <xsl:variable name="newAdapterClass">de.softproject.x4.auth.keycloak.KeycloakAdapter</xsl:variable>
  
  <xsl:template match="*">
    <xsl:copy>
      <xsl:apply-templates select="@*"/>
      <xsl:apply-templates select="node()"/>
    </xsl:copy>
  </xsl:template>
  
  <xsl:template match="@*">
    <xsl:copy-of select="."/>
  </xsl:template>
  
  <xsl:template match="text()|processing-instruction()|comment()">
    <xsl:copy-of select="."/>
  </xsl:template>
  
  <xsl:template match="adapter[@code=$oldAdapterClass]/@code">
    <xsl:attribute name="code">
      <xsl:value-of select="$newAdapterClass"/>
    </xsl:attribute>
  </xsl:template>
  
  <xsl:template match="adapter[@name=$oldAdapterClass]/@name">
    <xsl:attribute name="name">
      <xsl:value-of select="$newAdapterClass"/>
    </xsl:attribute>
  </xsl:template>
  
  <xsl:template match="adapter[@code=$oldAdapterClass]/properties/property[@iXname='Adapter']">
    <property basic_property="true"
                code=""
                comment="API to access and work with Keycloak."
                data_type="array"
                default_value="{$newAdapterClass}"
                iXname="Adapter"
                name="Adapter"
                optional="true"
                user_comment="Implementation class"
                value="{$newAdapterClass}">
         <AllowableValues>
            <Value iXname="{$newAdapterClass}"
                   value="{$newAdapterClass}"/>
         </AllowableValues>
      </property>
  </xsl:template>
</xsl:stylesheet>
<!--Created by X4 Designer, Copyright © SoftProject GmbH. All rights reserved.-->