<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="2.0">
  <xsl:output media-type="text/xml" method="xml"></xsl:output>
  <xsl:template match="*">
    <xsl:copy>
      <xsl:apply-templates select="@*"></xsl:apply-templates>
      <xsl:apply-templates select="node()"></xsl:apply-templates>
    </xsl:copy>
  </xsl:template>
  
  <xsl:template match="Workflow/Actions/Action[Module='iXcounter']/Parameters">
  	<xsl:choose>
  		<xsl:when test="Parameter[name='count']">
  			<Parameters>
		        <Parameter id="1">
		          <name>end</name>
		          <value>0</value>
		        </Parameter>
		        <Parameter id="2">
		          <name>step</name>
		          <value>1</value>
		        </Parameter>
		        <Parameter id="3">
		          <name>start</name>
		          <value><xsl:value-of select="Parameter[name='count']/value"></xsl:value-of></value>
		        </Parameter>
		        <Parameter id="4">
		          <name>indexName</name>
		          <value>CounterIndex</value>
		        </Parameter>
		      </Parameters>
  		</xsl:when>
  		<xsl:otherwise>
  			<xsl:copy>
		      <xsl:apply-templates select="@*"></xsl:apply-templates>
		      <xsl:apply-templates select="node()"></xsl:apply-templates>
		    </xsl:copy>
  		</xsl:otherwise>
  	</xsl:choose>
  </xsl:template>
  
  <xsl:template match="@*">
    <xsl:copy-of select="."></xsl:copy-of>
  </xsl:template>
  
  <xsl:template match="text()|processing-instruction()|comment()">
    <xsl:copy-of select="."></xsl:copy-of>
  </xsl:template>
</xsl:stylesheet>